require 'net/http'
require 'uri'

url = URI.parse('http://pastie.caboo.se/pastes/create')

parameters = {}
parameters['paste[authorization]'] = 'burger'

is_private = 'TRUE'.eql?(ENV['PASTIE_PRIVATE_FLAG'])
if is_private
  parameters['paste[restricted]'] = 1
end

name = ENV['SNIPPET_NAME']
puts "Uploading#{ is_private ? ' with Private flag' : '' }: #{name}"

parsers = {
  'plain-text' => 'plain_text',
  'objective-c' => 'objective-c_c++',
  'c' => 'c_c++',
  'cpp' => 'c_c++',
  'cs' => 'c#',
  'html' => 'html_xml',
  'xml' => 'html_xml',
  'xslt' => 'html_xml',
  'php' => 'php',
  'css' => 'css',
  'javascript' => 'javascript',
  'java' => 'java',
  'actionscript' => 'actionscript',
  'sql' => 'sql',
  'ruby' => 'ruby',
  'python' => 'python',
  'bash' => 'bash_shell',
  'apple-script' => 'plain_text',
  'cold-fusion' => 'cold_fusion',
  'regexp' => 'plain_text',
  'lisp' => 'lisp_common',
  'lua' => 'lua',
  'perl' => 'perl',
  'vb' => 'plain_text',
  'applescript-objc' => 'plain_text',
  'erlang' => 'erlang'
}

parameters['paste_parser'] = parsers[ENV['SNIPPET_SYNTAX_HIGHLIGHT']]
parameters['paste[body]'] = ENV['SNIPPET_SOURCE_CODE']

pastie_url = Net::HTTP.post_form(url, parameters).body.match(/href="([^\"]+)"/)[1]
pastie_url = pastie_url.gsub('pastie.caboo.se', 'pastie.org')

puts "Snippet is successfully uploaded at #{pastie_url}"

ENV['PASTIE_SNIPPET_URL'] = pastie_url